/*
 * Copyright (c) 2019, The Tor Project, Inc.
 * See LICENSE for licensing information.
 *
 * vim: set sw=2 sts=2 ts=8 et syntax=css:
 */

:root {
  --abouttor-text-color: white;
  --abouttor-bg-toron-color: #420C5D;
  --abouttor-bg-toroff-color: #A4000F;
  --abouttor-yec-page-bg-color: #0E0625;
  --abouttor-yec-heading-color: #C0FF00;
  --abouttor-yec-heading-alt-color: #FF60FF;
  --abouttor-yec-button-color: #000000;
  --abouttor-yec-button-bg-color: #C0FF00;
  --abouttor-yec-button-hover-bg-color: #A8DF00;
  --abouttor-yec-button-active-bg-color: #90BF00;
  --abouttor-yec-donate-text-color: #FAF5DF;
  --onion-opacity: 0.2;
  --onion-color: #fff;
  --onion-radius: 75px;
}

* {
  padding: 0px;
  margin: 0px;
}

html {
  height: 100%;
}

body {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  width: 100%;
  height: 100%;
  margin: 0px auto;
  padding: 0px 0px;
  font-family: Helvetica, Arial, sans-serif;
  color: var(--abouttor-text-color);
  background-color: var(--abouttor-bg-toroff-color);
  background-attachment: fixed;
  background-size: 100% 100%;
}

body[toron] {
  background-color: var(--abouttor-bg-toron-color);
}

body[toron]:not([hasbeenupdated]).isYEC {
  background-color: var(--abouttor-yec-page-bg-color);
}

/* Hide the entire document by default to avoid showing the incorrect
 * Tor on / off status (that info must be retrieved from the chrome
 * process, which involves IPC when multiprocess mode is enabled). An
 * initialized attribute will be added as soon as the status is known.
 */
body:not([initialized]) {
  display: none;
}

.torcontent-container {
  margin: 40px 20px 28px 20px;
  display: flex;
  flex-direction: column;
}

@media only screen and (min-width: 900px) {
  .torcontent-container {
    margin: 40px auto 28px auto;
    max-width: 1000px;
  }
}

body[toron]:not([hasbeenupdated]).isYEC .torcontent-container {
  margin-block-end: calc(28px + 4rem);
}

#torbrowser-info {
  position: absolute;
  top: 16px;
  offset-inline-end: 16px;
  inset-inline-end: 16px;
  height: 36px;
  width: 200px;
}

#torbrowser-info div {
  font-size: 14px;
  white-space: pre-wrap;
  text-align: end;
  margin-bottom: 6px;
}

/* Hide "View Changelog" link if update channel is not release or alpha. */
body:not([updatechannel="release"]):not([updatechannel="alpha"]) #torbrowser-changelog-link {
  display: none;
}

a {
  color: var(--abouttor-text-color);
}

#torstatus {
  margin-top: 135px;
  display: flex;
  flex-direction: column;
  align-content: center;
  justify-content: flex-end;
  min-height: 92px;
}

.top {
  white-space: nowrap;
}

.torstatus-container {
  text-align: center;
}

body[toron]:not([hasbeenupdated]).isYEC .hideIfYEC,
body:not(.isYEC) .showIfYEC,
body[hasbeenupdated] .hideIfHasBeenUpdated,
body[toron] .hideIfTorOn,
body:not([toron]) .hideIfTorOff {
  display: none;
}

body:not([hasbeenupdated]) .showIfHasBeenUpdated {
  display: none;
}

.torstatus-container * {
  text-align: center;
}

.top div.hideIfTorOff .heading1 {
  margin-top: 20px;
}

.top .heading1 {
  font-size: 50px;
  font-weight: 300;
  margin-bottom: 5px;
}

.top .heading2 {
  font-size: 15px;
  margin-bottom: 20px;
}

.yec-grid {
  display: grid;
  /* We use a three column grid. As such, if the button text content is shorter
   * than the image, then the middle column's width will collapse to zero, so
   * the donate-text and the sub-headings will be aligned at their start. If the
   * button text content is longer than the image, then the middle column's
   * width will grow to accommodate it. As such, the donate-text will no longer
   * be aligned with the sub-headings, but the gap will be roughly the same. */
  grid-template: "heading heading heading" min-content
                 "image sub-headings sub-headings" min-content
                 "button button donate-text" min-content
                 / auto auto auto;
  /* Center-align the grid relative to the yec-background-image. */
  width: min-content;
  margin-inline: auto;
  margin-block-end: 50px;
}

.yec-background-image {
  grid-area: image-start / image-start / image-end / sub-headings-end;
  margin-inline: -25px;
  margin-top: 45px;
  opacity: 0.8;
}

.yec-foreground-image {
  grid-area: image;
  z-index: 2;
  align-self: end;
  margin-inline: -55px 25px;
  margin-block: 15px 10px;
  mix-blend-mode: hard-light;
}

.yec-foreground-image:dir(rtl) {
  transform: scaleX(-1);
}

.yec-heading {
  grid-area: heading;
  font-size: 1.75rem;
  white-space: normal;
  color: var(--abouttor-yec-heading-color);
  line-height: 1.1;
  font-family: 'Space Mono', monospace;
  font-weight: 400;
  letter-spacing: -0.05em;
}

.yec-sub-headings {
  grid-area: sub-headings;
  margin-top: 20px;
  z-index: 2;
  /* Do not contribute to the min-content of the yec-grid.
   * This means that the yec-grid will remain center-aligned relative to the
   * yec-background-image, even if one of the sub-heading elements has long text
   * content that would normally grow the size of the grid. */
  width: 1px;
  line-height: 1.05;
  font-family: 'Space Grotesk', sans-serif;
  font-size: 60px;
  letter-spacing: -0.05em;
  mix-blend-mode: hard-light;
}

.yec-sub-heading-2 {
  color: var(--abouttor-yec-heading-color);
  font-weight: 300;
}

.yec-sub-heading-1,
.yec-sub-heading-3 {
  color: var(--abouttor-yec-heading-alt-color);
  font-weight: 500;
}

.yec-sub-headings,
.yec-background-image {
  transform: skewY(-2.25deg);
}

:is(
  .yec-sub-headings,
  .yec-background-image
):dir(rtl) {
  transform: skewY(2.25deg);
}

.yec-donate-button {
  grid-area: button;
  align-self: start;
  justify-self: end;
  margin-inline-end: 30px;
  color: var(--abouttor-yec-button-color);
  background-color: var(--abouttor-yec-button-bg-color);
  text-decoration: none;
  line-height: 1.4;
  padding: 13px 20px;
  border-radius: 8px;
  font-size: 1rem;
  font-family: 'Space Mono', monospace;
  font-weight: 700;
}

.yec-donate-button:hover {
  background-color: var(--abouttor-yec-button-hover-bg-color);
}

.yec-donate-button:active {
  background-color: var(--abouttor-yec-button-active-bg-color);
}

.yec-donate-button:focus-visible {
  outline: 2px solid var(--abouttor-yec-button-bg-color);
  outline-offset: 2px;
}

.yec-donate-text {
  grid-area: donate-text;
  color: var(--abouttor-yec-donate-text-color);
  white-space: normal;
  font-size: 1.1rem;
  line-height: 1.4;
  font-family: 'Space Mono', monospace;
  font-weight: 400;
}

#bottom {
  margin-top: 10vh;
  margin-inline: auto;
  max-width: 730px;
}

#bottom p {
  font-size: 10px;
  text-align: start;
  padding-bottom: 20px;
}

#bottom p:last-child {
  padding-bottom: 0px;
}

#bottom p.moreInfoLink {
  font-size: 15px;
}

#bottom img.imageStyle {
  padding-inline-end: 0.5em;
  height: 1.5em;
  vertical-align: bottom;
  -moz-context-properties: fill;
  fill: white;
}

/* Hide the linebreaks on large enough screens (desktops, laptops, and
 * tablets).
 */
@media only screen and (min-width: 768px) {
  #bottom br {
    display: none;
  }
}

.searchbox form {
  max-width: 575px;
  width: auto;
  margin-block: 0;
  margin-inline: auto;
  text-align: left;
}

.searchwrapper {
  display: flex;
  height: 46px;
  border: 1px solid black;
  border-radius: 8px;
  background-color: white;
}

.searchlabel {
  height: auto;
  width: 50px;
  display: inline-block;
  background: url('dax-logo.svg') no-repeat center center;
  background-size: 30px 30px;
}

#search-button {
  height: auto;
  width: 36px;
  border: 0;
  background: url('chrome://browser/skin/forward.svg') no-repeat center center;
  background-size: 16px 16px;
  cursor: pointer;
}

#search-button:dir(rtl) {
  transform: scaleX(-1);
}

#search-button:hover {
  background-color: rgba(12, 12, 13, 0.1);  /* same as Firefox's about:home */
}

#bannerRoot {
  width: 690px;
  padding: 20px 25px 25px;
  background: rgba(0, 0, 0, 0.3);
  border-radius: 6px;
  margin: 35px auto 0px;
  display: flex;
  flex-direction: row;
  align-items: flex-start;
  position: static;
}

#bannerTextCol {
  padding-top: 8px;
  padding-inline-start: 15px;
  font-size: 15px;
  line-height: normal;
  color: #FFFFFF;
  width: 633px;
}

#bannerHeader {
  font-weight: bold;
}

#bannerImg {
    width: 32px;
    position: static;
}

a#bannerLink {
  text-decoration: underline;
}

a#bannerLink:hover {
  text-decoration: none;
}

/* #search-text is the search input field */
#search-text {
  flex: 1;
  border: none;
  padding: 4px 2px 5px 2px;
  margin: 0;
  font-size: 15px;
}

#search-text:focus-visible {
  outline: none;
}

#search-button:focus-visible {
  outline: 1px dotted black;
  outline-offset: -6px;
}


/*
 * Mobile specific css
 */

.torcontent-logo {
  display: none;
}

body[mobile] #torbrowser-changelog-link,
body[mobile] .searchbox,
body[mobile] .top .heading2,
body[mobile] #manual,
body[mobile] #mission {
  display: none;
}

body[mobile] .top {
  white-space: normal;
  margin-top: 0px !important;
}

body[mobile] .torcontent-logo {
  display: block;
  margin-top: 20px;
  width: 50%;
  height: auto;
  margin-left: auto;
  margin-right: auto;
}

body[mobile] .top .heading1 {
  font-size: 62px;
  line-height: 1.1
}

body[mobile] .onion-pattern-container {
  flex: none;
  z-index: -1; /* ensure that circles do not block access to clickable links */
  position: absolute;
  bottom: 0px;
}
